SystemOrganization addCategory: #PoemPoem!

Object subclass: #PoemPoem
	instanceVariableNames: 'poem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PoemPoem'!

!PoemPoem class methodsFor: 'as yet unclassified' stamp: 'SeungBumKim 1/11/2013 16:23'!
open

	| ui pp |
	pp := PoemPoem new.
	ui := QuickPrototyping for: pp.
	(ui column: {
		ui title: 'Poem Text' text: #poem  width: 200. 
		ui button: 'Sing a poem' action: #sing.}) openInWindow.! !

!PoemPoem methodsFor: 'as yet unclassified' stamp: 'SeungBumKim 1/11/2013 13:27'!
poem
	^poem! !

!PoemPoem methodsFor: 'as yet unclassified' stamp: 'SeungBumKim 1/11/2013 13:28'!
poem: aText 
	poem := aText. self changed: #poem.! !

!PoemPoem methodsFor: 'as yet unclassified' stamp: 'SeungBumKim 1/11/2013 16:27'!
sing
	self sing: self poem.! !

!PoemPoem methodsFor: 'as yet unclassified' stamp: 'SeungBumKim 1/11/2013 13:19'!
sing: poem
| sequence sound p |
sequence := SequentialSound new.

poem do: [:char |  |num|
	num := (char asInteger - 44032 * 0.03 + 100) asFloat*1.7.
	sound := FMSound new.

	"sound addEnvelope: (VolumeEnvelope exponentialDecay: 0.96).
	sound addEnvelope: (PitchEnvelope exponentialDecay: 0.98).
	sound setPitch: num dur: 0.3 loudness: 0.5."

	p := OrderedCollection new.
	p add: 0@0; add: 60@1.0; add: 110@0.8; add: 200@1.0; add: 250@0.0.
	sound addEnvelope: (VolumeEnvelope points: p loopStart: 2 loopEnd: 4).
	sound setPitch: (num max: 0) dur: 0.2 loudness: 0.5.
	
	sequence add: sound.
].

sequence play.! !
